library(rgl);
seq=NULL
HUM=NULL
varInput=NULL
shinyServer(function(input, output,session) {

  source("CalculateHUM_seq.R",local=TRUE);
  source("CalculateHUM_ROC.R",local=TRUE);
  source("ROC_Plot.R",local=TRUE);
  source("CalculateHUM_Ex.R",local=TRUE);
  sourceCpp("HUMseq.cpp");
  
  values <- reactiveValues(mode = 'none')
  MaxClass=10
  open3d()
  Tipp<-function(dat,feature){
    Judge<-0
    for(i in 1:length(feature))
    { 
      if(!is.numeric(dat[,which(names(dat)==feature[[i]])]))
      {  
        Judge<-1			
        break
      }
    }
    Judge
  }
  
  observe({
    if (!is.null(input$file1)) {
      values$mode <- 'file'
    }
  })
  
  observe({
    #if (identical(input$tabs1, "Result")) {
      #isImageAvailable <- ...   # presumably this would invoke accessing a reactive value or expr
      
      if (is.null(input$ROCButton))
        return(NULL)
      if (input$ROCButton == 0)
        return(NULL)
      
     
      isolate({ 
     
        updateTabsetPanel(session, "tabs1", selected="ROC curve")
      
      })
    #}
  })
  
  observe({
    #if (identical(input$tabs1, "Result")) {
    #isImageAvailable <- ...   # presumably this would invoke accessing a reactive value or expr
    
    if (is.null(input$barButton))
      return(NULL)
    if (input$barButton == 0)
      return(NULL)
    
    
    isolate({ 
 
      updateTabsetPanel(session, "tabs1", selected="Bar Chart")
      
    })
    #}
  })
  
  observe({
    #if (identical(input$tabs1, "Result")) {
    #isImageAvailable <- ...   # presumably this would invoke accessing a reactive value or expr
    
    if (is.null(input$goButton))
      return(NULL)
    if (input$goButton == 0)
      return(NULL)
    
    
    isolate({ 
    
      updateTabsetPanel(session, "tabs1", selected="Result")
      
    })
    #}
  })
  
  observe({
    if(is.null(input$file1)) return(NULL)
    if(funData()==0) return(NULL)
    
    
    updateTabsetPanel(session, "tabs1", selected="Data set")

  })
  
  
  funData<-function()
    ({
      var=0
      
      if(is.null(varInput)) 
      {
        varInput<<-input$file1
        var=1
      }  
      else
      {
      if(varInput$name!=input$file1$name)
      {
        var=1
        varInput<<-input$file1
      }
      }
      var
    })
      
  datasetInput <- reactive({
    
    switch(values$mode,
           none = NULL,
           
           file = {
             #read.delim((input$file1)$datapath,header=T,sep='\t',row.names=1,as.is=T)
             
             read.delim((input$file1)$datapath,header=T,sep='\t',as.is=T)
             
           }
    )
  })
  
  output$download <- renderUI({
    if (is.null(datasetInput()))
      return(NULL)
  downloadButton('downloadData', 'Download Data')
  })
  
  output$decimal<-renderUI({
    if(input$scient==TRUE)
      numericInput("decimals","Decimal digits",2)
  })
  
  
  
  output$choose_feature <- renderUI({
    if (is.null(datasetInput()))
      return(NULL)
    #browser()
    selectInput("feature", "Feature", as.list(names(datasetInput())), selected=NULL,multiple = TRUE)
  })
  
   
  output$choose_class <- renderUI({
    if (is.null(datasetInput()))
      return(NULL)
    
    selectInput("class", "Class", as.list(names(datasetInput())))
   
    
  })
  
  labelInput<-function(class){
    dat <- class
    #browser()
    if(!dat%in%colnames(datasetInput())) return(NULL)
    
    ttt<-datasetInput()[,dat]
    
    ttt1<-unique(ttt)
    ttt01<-c()
    
    for(i in 1:length(ttt1))
    {
      if(!is.na(ttt1[i]))
      {
      if(ttt1[i]!="")
      {
        ttt01<-c(ttt01,ttt1[i])
      }
      }
    }
   
    ttt01
  }
  
  flag_label <- reactive({
    if(is.null(input$class)) return (NULL)
    ttt1=labelInput(input$class)
    if(is.null(ttt1)) return (NULL)
    if((length(ttt1)>1)&&(length(ttt1)<=MaxClass))
    { 
      var<-1
    }
    else
    {
      var=0
    }
    var
  })
  
  var_label <- reactive({
    input$goButton
    isolate({
      var=input$label
    })
    var
  })
  
  var_ex <- reactive({
    input$goButton
    isolate({
      var=input$ex
    })
    var
  })
  
  var_class <- reactive({
    input$goButton
    isolate({
      var=input$class
    })
    var
  })
  
  var_amount <- reactive({
    input$goButton
    isolate({
      var=input$amount_label
    })
    var
  })
  
  var_feature <- reactive({
    input$goButton
    isolate({
      var=input$feature
    })
    var
  })
    
  output$choose_label <- renderUI({
    if(is.null(input$class)) return()
    #browser()
    if(input$ex==FALSE)
    {
      ttt1<-labelInput(input$class)
      if(is.null(ttt1)) return ()
      if((length(ttt1)>1)&&(length(ttt1)<=MaxClass))
      {
        selectInput("label", "Label", as.list(ttt1), selected=NULL, multiple = TRUE)
       
      }

    }
    else
    {
      return()
    }	
     
  } )
  
  output$choose_amount_label<-renderUI({
    if(is.null(input$class)) return()
    #browser()
    if(input$ex==FALSE)
    {return()}else{
      ttt1<-labelInput(input$class)
      if(is.null(ttt1)) return ()
      if((length(ttt1)>1)&&(length(ttt1)<=MaxClass))
      {
      sliderInput("amount_label","Number of labels", min=2,max=length(ttt1),value=2,step=1)
      }
    }
  }) 
 
  
  
  output$ROCselect <- renderUI({
    
    #if (input$goButton == 0)
     # return(NULL)
    input$goButton
    isolate({
      dat<-datasetInput()
      if(is.null(input$feature))
      {return()
      }else
      {
        for(i in 1:length(input$feature))
        { 
          if(!is.numeric(dat[,which(names(dat)==input$feature[[i]])]))
          {  
            return()
            break
          }
        }
      }
    
    if(input$ex)
    {
      if(flag_label()==0) return()
      if(is.null(input$amount_label)) return()
      if(input$amount_label==2||input$amount_label==3)
      {
        selectInput("select", "Select Variable", as.list(input$feature), selected=NULL)
      }
    }
    else
    {
      if(flag_label()==0) return()
      if(length(input$label)==2||length(input$label)==3)
      {
        selectInput("select", "Select feature", as.list(input$feature), selected=NULL)
      }
    }
    
  })
  })
  
  output$ROCbutton <- renderUI({
    if (input$goButton == 0)
      return(NULL)
    isolate({
      dat<-datasetInput()
      if(is.null(input$feature))
      {return()
      }else
      {
        for(i in 1:length(input$feature))
        { 
          if(!is.numeric(dat[,which(names(dat)==input$feature[[i]])]))
          {  
            return()
            break
          }
        }
      }
      if(input$ex)
      {
        if(flag_label()==0) return()
        if(is.null(input$amount_label)) return()
        if((input$amount_label==2)||(input$amount_label==3))
          actionButton("ROCButton", "Plot ROC!")
      }
      else
      {
        if(flag_label()==0) return()
        if(length(input$label)==2||length(input$label)==3)
        {
          actionButton("ROCButton", "Plot ROC!")
        }
      }
        
      })
    })
  
  
  output$text <- renderText({
    if (input$goButton == 0)
      return(NULL)
    
    isolate({
      
      dat<-datasetInput()
      #browser()
      if(is.null(input$feature)) 
      {
        text<-"Select feature!"        
      }
      else
      {
        judge<-Tipp(dat,input$feature)
        
        if(judge==1)
        {
          text<-"Some inputs are not the feature. Select right features!"
        }else
        {		
          if(is.null(input$class)) 
          {
            text<-"Select class!"
          }else
          {
            if(!input$ex)
            {
              ttt1<-labelInput(input$class)
              if(is.null(ttt1)) return ()
              if((length(ttt1)<=1)||(length(ttt1)>MaxClass))
              {
                text<-"Class has less as two labels or more than max value. Select another class!"
              }else
              {
                if(length(input$label)<=1) 
                {
                  text<-"Select two or more class labels!"
                }
              }        
            }
            else
            {
              if(is.null(input$amount_label)||(flag_label()==0)) 
                text<-"Class has less as two labels or more than max value. Select another class!"
            }
          }
        }
      }
    })
    
  })
  
  
  
  output$go_barchart<-renderUI({
    if (input$goButton == 0)
      return(NULL)
    
    isolate({
      dat<-datasetInput()
      if(is.null(input$feature))
      {return()
      }else
      {
        for(i in 1:length(input$feature))
        { 
          if(!is.numeric(dat[,which(names(dat)==input$feature[[i]])]))
          {  
            return()
            break
          }
        }
      }
      
      if(input$ex)
      {
        if(flag_label()==0) return()
        if(is.null(input$amount_label)) return()
        actionButton("barButton","Bar chart!")
      }
      else
      {
        if(flag_label()==0) return()
      if(length(input$label)>1)      
        actionButton("barButton","Bar chart!")	  
      }
      
    })
  })
  
  output$VarSelect <- renderUI({
    
    if (input$goButton == 0)
      return(NULL)
    isolate({
      dat<-datasetInput()
      if(is.null(input$feature))
      {return()
      }else
      {
        for(i in 1:length(input$feature))
        { 
          if(!is.numeric(dat[,which(names(dat)==input$feature[[i]])]))
          {  
            return()
            break
          }
        }
      }
      if(input$ex)
      {
        if(flag_label()==0) return()
        if(is.null(input$amount_label)) return()
        #if((input$amount_label==2)||(input$amount_label==3))
        #{
          ttt1<-labelInput(input$class)
          if(length(ttt1)>1)
          {
            res=choose(length(ttt1),input$amount_label)
          }
          numericInput("var",  "Select labels", 1, min = 1, max = res,
                       step = 1)
      }
    })
  })
  

  output$table1 <- renderTable({
    
    if (is.null(datasetInput()))
      return(NULL)
    
    if(input$scient==TRUE)
    {
      format(datasetInput(),digits=input$decimals,sci=TRUE)
    }else{format(datasetInput(),sci=FALSE)}
    
  })
  
  
  output$table2 <- renderTable({
    
    if (input$goButton == 0)
      return(NULL)
      isolate({
        dat<-datasetInput()
        if(length(input$feature)==0) 
        {
          return()
        }else
        {
          for(i in 1:length(input$feature))
          { 
            if(!is.numeric(dat[,which(names(dat)==input$feature[[i]])]))
            {  
              return()
              break
            }
          }
        }
        
        if(input$ex==FALSE)
        {
          if(flag_label()==0) return()
          if(length(input$label)<2)
          {
            return()
          }
          ptm <- Sys.time()
          out=CalculateHUM_seq(datasetInput(),input$feature,input$class,input$label)
          cat("Elapsed time =",format(Sys.time()-ptm), "\n")
        }
        else
        {
          if(flag_label()==0) return()
          #ttt1<-labelInput(input$class)
          #if(length(ttt1)<=1) return()
          if(is.null(input$amount_label)) return()
          ttt1<-labelInput(input$class)
          if(is.null(ttt1)) return ()
          ptm <- Sys.time()
          out=CalculateHUM_Ex(datasetInput(),input$feature,input$class,ttt1,input$amount_label)
          cat("Elapsed time =",format(Sys.time()-ptm), "\n")
        }
        
        
        HUM<<-out$HUM
        seq<<-out$seq
        if(input$ex==FALSE)
        {
          HUM_Value=sprintf("%.3f",out$HUM)
          names(HUM_Value)=input$feature
        }
        else
        {
          HUM_Value=out$HUM
        }
        data.frame(HUM_Value)
      })
  }) 
  
  
  output$downloadData <- downloadHandler(
    
    filename = function() { paste(values$mode, '.csv', sep='') },
    content = function(file) {
     
      write.csv(datasetInput(), file)
    }
  )
  
  output$plot1 <- renderPlot({
    
    
    if (is.null(input$ROCButton))
      return(NULL)
    if (input$ROCButton == 0)
    return(NULL)
   
    isolate({
    # if(is.null(input$sel)) return()
    #sel=input$sel
      
    if(!var_ex())
    {
    sel=input$select
    
    #cat("HUM1",HUM)
    if(length(var_label())==2)
    {
      out=CalculateHUM_ROC(datasetInput(),sel,var_class(),var_label(),seq)
      print(CalculateHUM_Plot(sel,out$Sn,out$Sp,out$optSn,out$optSp,HUM))
    }
    else
    {
      if(length(var_label())==3)
      {
        out=CalculateHUM_ROC(datasetInput(),sel,var_class(),var_label(),seq)
        
        print(Calculate3D(sel,out$Sn,out$Sp,out$S3,out$optSn,out$optSp,out$optS3,out$thresholds,HUM,var_label()[seq]))
      }
      else
      {
      return()
      }
    }
    }
    else
    {
      sel=input$select
      var=input$var
      
      if(var>nrow(HUM)) return()
      
      HUMout=as.numeric(HUM[var,-(1:var_amount())])
      names(HUMout)=var_feature()
      
      if(var_amount()==2)
      {
        vremLabel=HUM[var,1:var_amount()]
        out=CalculateHUM_ROC(datasetInput(),sel,var_class(),vremLabel,seq[[var]])
        print(CalculateHUM_Plot(sel,out$Sn,out$Sp,out$optSn,out$optSp,HUMout))
       
      }
      else
      {
        if(var_amount()==3)
        {
          vremLabel=HUM[var,1:var_amount()]
          out=CalculateHUM_ROC(datasetInput(),sel,var_class(),vremLabel,seq[[var]])
         
          print(Calculate3D(sel,out$Sn,out$Sp,out$S3,out$optSn,out$optSp,out$optS3,out$thresholds,HUMout,as.character(vremLabel)[seq[[var]]]))
          
        }
        else
        {
        return()
        }
      }
      
    }
    })
  })
  
  output$plot2 <- renderPlot({
    #browser()
    if (is.null(input$barButton))
      return(NULL)
    if (input$barButton == 0)
      return(NULL)
    
    isolate({
      if(!var_ex())
      {
        if(length(var_label())>1)
        {
          barplot(HUM,main="HUM values-Bar Chart")
          y<-1/factorial(length(var_label()))
          abline(h=y,col="red",lwd=2)
          text(1,y,paste("Threshold=",sprintf("%.3f",y),sep=""),col="red",adj = c(0, -.2))
          dev.off()	
        }
        else
        {
          return()
        }
      }
      else
      {
        if(is.null(var_amount())) return()
        var=input$var
        if(var>nrow(HUM)) return()
        out=as.numeric(HUM[var,-(1:var_amount())])
        names(out)=var_feature()
        
        barplot(out,main="HUM values-Bar Chart")
        y<-1/factorial(var_amount())
        abline(h=y,col="red",lwd=2)
        text(1,y,paste("Grenz=",sprintf("%.3f",y),sep=""),col="red",adj = c(0, -.2))
        dev.off()
      }
    })
  })

})